var webView; //窗口对象 
var userId; //当前登录用户ID
var _workerTel; // 当前师傅联系电话
var _evaluationId; //当前登录用户对师傅的评价记录ID
var _evaluationLevel; //当前登录用户对师傅的评价值 0:一般, 1:好评
var _pavoriteId; ////当前登录用户对师傅的收藏记录ID
var _pavoriteStatus; //当前登录用户对师傅的收藏状态 0:为收藏, 1:已收藏
var shares = null; //分享服务列表
var vCardUrl; //电子名片地址
mui.init();
mui.previewImage();
mui.plusReady(function() {
    webView = plus.webview.currentWebview();
    userId = plus.storage.getItem("user_id");
    getDetail(webView.userId);
    updateSerivces();
    if(webView.userId == userId) {
        var qr = shareurl + "haoshifu-app/worker/detail.html?userId=" + webView.userId;
        document.getElementById("user-qrcode").src = "http://pan.baidu.com/share/qrcode?w=300&h=300&url=" + qr;
        document.getElementById("qrcode-tip").style.display = "block";
        document.getElementById("user-qrcode").style.display = "inline-block";
    }
});
//免责声明
document.getElementById("exemption").addEventListener("tap", function() {
    mui.openWindow({
        url: "exemption.html"
    });
});
mui(".mark-box").on("tap", "#pingbacks", function(e) {
    if(!userId) {
        mui.toast("请登录后再留言");
        return false;
    }
    var msg = mui("#msg-textarea")[0].value;
    if(msg.trim() == "") {
        mui.toast("留言不可为空");
        return false;
    }
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    var data = {
        userId: userId,
        workerId: webView.userId,
        msgDetail: msg
    }
    AJAX.post("workerMsg/save", data, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status != 1) {
            mui.toast(xhr.msg);
            return false;
        } else {
            mui.toast("留言成功");
            getWorkerMsg(webView.userId, true);
            //getDetail(webView.userId);
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    });
});
mui("#evaluation-box").on("tap", ".js-evaluation", function(e) {
    if(userId) {
        var level = this.getAttribute("evaluation-level");
        level = parseInt(level);
        var levelText = level ? "好评" : "一般";
        if(typeof(_evaluationLevel) == "number") {
            if(level == _evaluationLevel) {
                mui.toast("您已经给了师傅" + levelText + "评价");
                return false;
            }
        }
        var btnArray = ['否', '是'];
        mui.confirm('确认给师傅' + levelText + '评价？', '', btnArray, function(e) {
            if(e.index == 1) {
                setEvaluation(level);
            }
        });
    } else {
        mui.toast("请登录后再对师傅评价");
    }
});
mui(".mui-media-body").on("tap", "#pavorite-btn", function(e) {
    if(userId) {
        var msg = _pavoriteStatus ? "取消" : "";
        var btnArray = ['否', '是'];
        mui.confirm('确认' + msg + '收藏该师傅？', '', btnArray, function(e) {
            if(e.index == 1) {
                setPavorite(_pavoriteStatus);
            }
        });
    } else {
        mui.toast("请登录后再收藏该师傅");
    }
});
//展开，收起
mui("body").on("tap", ".js-ellipsis", function() {
    if(this.classList.contains("mui-active")) {
        this.classList.remove("mui-active");
        this.innerHTML = '展开<i class="mui-icon mui-icon-arrowdown mui-h6"></i>';
        document.getElementById(this.getAttribute("p-id")).classList.add("mui-ellipsis-2");
    } else {
        this.classList.add("mui-active");
        this.innerHTML = '收起<i class="mui-icon mui-icon-arrowup mui-h6"></i>';
        document.getElementById(this.getAttribute("p-id")).classList.remove("mui-ellipsis-2");
    }
})
document.getElementById("share").addEventListener("tap", function() {
    shareHref();
});
/**
 * 更新分享服务
 */
function updateSerivces() {
    plus.share.getServices(function(s) {
        shares = {};
        for(var i in s) {
            var t = s[i];
            shares[t.id] = t;
        }
    }, function(e) {
        console.log("获取分享服务列表失败：" + e.message);
    });
}
// 分析链接
function shareHref() {
    var shareBts = [];
    // 更新分享列表
    var ss = shares['weixin'];
    ss && ss.nativeClient && (shareBts.push({
            title: '微信朋友圈',
            s: ss,
            x: 'WXSceneTimeline'
        }),
        shareBts.push({
            title: '微信好友',
            s: ss,
            x: 'WXSceneSession'
        }));
    // 弹出分享列表
    shareBts.length > 0 ? plus.nativeUI.actionSheet({
        title: '分享好师傅电子名片',
        cancel: '取消',
        buttons: shareBts
    }, function(e) {
        (e.index > 0) && shareAction(shareBts[e.index - 1], true);
    }) : plus.nativeUI.alert("您没有微信客户端", "无法分享");
}
/**
 * 分享操作
 * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
 * @param {Boolean} bh 是否分享链接
 */
function shareAction(sb, bh) {
    console.log("分享操作：");
    if(!sb || !sb.s) {
        console.log("无效的分享服务！");
        return;
    }
    var msg = {
        extra: {
            scene: sb.x
        }
    };
    if(bh) {
        var picturesUrl = "http://haoshifu.oss-cn-beijing.aliyuncs.com/app/app%E5%9B%BE%E6%A0%87-01.png";
        var thumbsUrl = "http://haoshifu.oss-cn-beijing.aliyuncs.com/app/180x180.png";
        var skill = mui("#worker-skill1Name")[0].innerHTML;
        var service = mui("#worker-service1Name")[0].innerHTML;
        vCardUrl = shareurl + "haoshifu-app/worker/detail.html?userId=" + webView.userId;
        msg.href = vCardUrl;
        msg.title = document.getElementById("worker-name").innerText;
        msg.content = "使用好师傅O2O名片，工作自己来找你！"; //"我推荐一位"+ skill +"好师傅，擅长"+ service +"服务";
        msg.thumbs = [thumbsUrl];
        msg.pictures = [picturesUrl];
    } else {
        return;
    }
    // 发送分享
    if(sb.s.authenticated) {
        console.log("---已授权---");
        shareMessage(msg, sb.s);
    } else {
        console.log("---未授权---");
        sb.s.authorize(function() {
            shareMessage(msg, sb.s);
        }, function(e) {
            console.log("认证授权失败：" + e.code + " - " + e.message);
        });
    }
}
/**
 * 发送分享消息
 * @param {JSON} msg
 * @param {plus.share.ShareService} s
 */
function shareMessage(msg, s) {
    s.send(msg, function() {
        mui.toast("分享到\"" + s.description + "\"成功！ ");
    }, function(e) {
        console.log("分享到\"" + s.description + "\"失败: " + JSON.stringify(e));
    });
}

function setPavorite(status) {
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    var url = "favorite";
    var method = "POST";
    var data = {
        userId: userId,
        workerId: webView.userId
    }
    if(status) {
        url += "/delete/" + _pavoriteId;
        method = "DELETE";
    } else {
        url += "/save";
    }
    AJAX.post(url, data, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status) {
            mui.toast("操作成功");
            getFavorite();
        } else {
            mui.toast("操作失败");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    }, method);
}

function setEvaluation(level) {
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    if(userId) {
        var url = "evaluation";
        var method = "POST";
        var data = {
            userId: userId,
            workerId: webView.userId,
            evaluationLevel: level
        };
        if(_evaluationId) {
            data["id"] = _evaluationId;
            url += "/update/" + _evaluationId;
            method = "PUT";
        } else {
            url += "/save";
        }
        AJAX.post(url, data, function(xhr) {
            plus.nativeUI.closeWaiting();
            if(xhr.status == 1) {
                mui.toast("评价成功");
                getEvaluationUweva(true);
            } else {
                mui.toast(xhr.msg ? xhr.msg : "评价失败请重试");
            }
        }, function(xhr) {
            plus.nativeUI.closeWaiting();
            mui.toast("网络连接失败，请重试");
        }, method);
    } else {
        plus.nativeUI.closeWaiting();
        mui.toast("请登录后再对师傅评价");
    }
}

function getFavorite() {
    var pavoriteBtn = mui("#pavorite-btn")[0];
    var url = "favorite/list?workerId=" + webView.userId + "&userId=" + userId;
    AJAX.get(url, function(xhr) {
        getFavoriteNum();
        _pavoriteStatus = xhr.total;
        if(xhr.total) {
            //取消收藏
            _pavoriteId = xhr.content[0].id;
            pavoriteBtn.innerHTML = "取消收藏";
        } else {
            //收藏
            pavoriteBtn.innerHTML = "收藏";
        }
        plus.nativeUI.closeWaiting();
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
    });
}
/**
 * 获取师傅收藏数量
 */
function getFavoriteNum() {
    var url = "userWorker/getVal/get/" + webView.userId + "?btype=favorite";
    AJAX.get(url, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            document.getElementById("worker-favoriteVal").innerHTML = xhr.content.val;
        } else {
            mui.toast(xhr.msg ? xhr.msg : "");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请稍后重试");
    });
}
/**
 * 获取师傅预约数量
 */
function getAppointmentNum() {
    var url = "userWorker/getVal/get/" + webView.userId + "?btype=appointment";
    AJAX.get(url, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            document.getElementById("worker-appointmentVal").innerHTML = xhr.content.val;
        } else {
            mui.toast(xhr.msg ? xhr.msg : "");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请稍后重试");
    });
}

function getEvaluationUweva(stop) {
    if(userId) {
        var url = "evaluation/userWorkerEva/get?workerId=" + webView.userId + "&userId=" + userId;
        AJAX.get(url, function(xhr) {
            !stop && getFavorite();
            if(xhr.status == 1) {
                initEvaluation(xhr);
            }
        }, function(xhr) {
            !stop && getFavorite();
        });
    } else {
        plus.nativeUI.closeWaiting();
    }
}

function getEvaluationNum() {
    var url = "userWorker/getVal/get/" + webView.userId + "?btype=favorable";
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            document.getElementById("worker-favorableVal").innerHTML = xhr.content.val;
            var url = "userWorker/getVal/get/" + webView.userId + "?btype=badval";
            AJAX.get(url, function(xhr) {
                if(xhr.status == 1) {
                    document.getElementById("worker-unfavorableVal").innerHTML = xhr.content.val;
                } else {
                    mui.toast(xhr.msg ? xhr.msg : "");
                }
            }, function(xhr) {
                mui.toast("网络连接失败，请稍后重试");
            });
        } else {
            mui.toast(xhr.msg ? xhr.msg : "");
        }
    }, function(xhr) {
        mui.toast("网络连接失败，请稍后重试");
    });
}

function initEvaluation(data) {
    getEvaluationNum();
    if(!data.content[0]) {
        return;
    }
    var level = data.content[0].evaluationLevel;
    _evaluationLevel = parseInt(level);
    _evaluationId = data.content[0].id;
    if(level == "1") {
        mui("#evaluation-level-0")[0].style.borderColor = "#cccccc";
        mui("#evaluation-level-1")[0].style.borderColor = "#f09133";
    } else {
        mui("#evaluation-level-0")[0].style.borderColor = "#f09133";
        mui("#evaluation-level-1")[0].style.borderColor = "#cccccc";
    }
}

function getWorkerMsg(id, stop) {
    var url = "workerMsg/list?workerId=" + id;
    AJAX.get(url, function(xhr) {
        initWorkerMsg(xhr);
        !stop && getEvaluationUweva();
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    });
}

function initWorkerMsg(data) {
    document.getElementById("worker-msgVal").innerHTML = data.total; //留言总数
    var msgList = document.getElementById("msg-list");
    msgList.innerHTML = "";
    for(var i in data.content) {
        var optionStyle = data.content[i].userId == userId ? "" : "display:none";
        optionStyle = userId == webView.userId ? "" : optionStyle;
        var html = '<div id="mark-item-' + data.content[i].id + '" class="mark-item">' +
            '    <p>' +
            '        <span>' + data.content[i].tel + '</span>' +
            '        <span class="mui-pull-right">' + data.content[i].createTime + '</span>' +
            '    </p>' +
            '    <p><span class="mui-ellipsis-2">' + data.content[i].msgDetail + '</span></p>' +
            '    <p style="' + optionStyle + '">' +
            '        &nbsp;' +
            '        <span worker-msg-id="' + data.content[i].id + '" class="js-delete mui-pull-right mui-h6">' +
            '            <i class="mui-icon ms mui-h6">&#xe62e;</i><span>删除</span>' +
            '        </span>' +
            '    </p>' +
            '</div>';
        msgList.innerHTML += html;
    }
    mui(".mark-item").on("tap", ".js-delete", function(e) {
        var id = this.getAttribute("worker-msg-id");
        var btnArray = ['否', '是'];
        mui.confirm('删除此留言，确认？', '', btnArray, function(e) {
            if(e.index == 1) {
                deleteMsg(id);
                //mui.toast('删除成功');
            } else {
                //mui.toast('取消删除');
            }
        });
    });
}

function deleteMsg(id) {
    if(!userId) {
        mui.toast("未登录,不可删除留言");
        return false;
    }
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    var data = {
        userId: userId,
        workerId: webView.userId
    }
    AJAX.post("workerMsg/delete/" + id, data, function(xhr) {
        plus.nativeUI.closeWaiting();
        if(xhr.status == 1) {
            mui.toast("删除成功");
            getWorkerMsg(webView.userId, true);
        } else {
            mui.toast(xhr.msg);
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    }, "DELETE");
}

function getDetail(id) {
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    var url = "userWorker/getUser/" + id;
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            initDetail(xhr);
            getWorkerMsg(id);
        } else if(xhr.status == 3) {
            plus.nativeUI.closeWaiting();
            mui.openWindow({
                url: "card_closed.html",
                id: "card_closed.html"
            });
        } else if(xhr.status == 4) {
            plus.nativeUI.closeWaiting();
            mui.openWindow({
                url: "card_masked.html",
                id: "card_masked.html"
            });
        } else {
            plus.nativeUI.closeWaiting();
            mui.alert(xhr.msg ? xhr.msg : "获取师傅信息失败，请重试", function() {
                mui.back();
            });
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请重试");
    });
}

function initDetail(xhr) {
    vCardUrl = xhr.content.vCardUrl;
    _workerTel = xhr.content.tel;
    mui("#worker-icon")[0].src = xhr.content.icon;
    mui("#worker-code")[0].innerHTML = "师傅号:" + xhr.content.code;
    mui("#worker-name")[0].innerHTML = xhr.content.userName ? xhr.content.userName : "";
    if(xhr.content.sex == "0") {
        document.getElementById("worker-sex").innerHTML = "&#xe635;";
        document.getElementById("worker-sex").classList.add("txc-b");
    } else {
        document.getElementById("worker-sex").innerHTML = "&#xe634;";
        document.getElementById("worker-sex").classList.add("txc-o");
    }
    mui("#worker-type")[0].innerHTML = xhr.content.typeId == 5 ? "VIP" : "注册";
    mui("#worker-certification")[0].style.color = xhr.content.certification ? "#f0ad4e" : "#cccccc";
    if(!xhr.content.certification) {
        document.getElementById("certificationText").innerHTML = "未实名登记";
    }
    mui("#worker-rate")[0].innerHTML = xhr.content.rate;
    mui("#worker-popuVal")[0].innerHTML = xhr.content.popuVal ? xhr.content.popuVal : 0;
    if(xhr.content.skill1Name) {
        mui("#worker-skill1Name")[0].innerHTML = xhr.content.skill1Name;
    } else {
        mui("#worker-skill1Name")[0].style.display = "none";
    }
    if(xhr.content.skill2Name) {
        mui("#worker-skill2Name")[0].innerHTML = xhr.content.skill2Name;
    } else {
        mui("#worker-skill2Name")[0].style.display = "none";
    }
    if(xhr.content.service1Name) {
        mui("#worker-service1Name")[0].innerHTML = xhr.content.service1Name;
    } else {
        mui("#worker-service1Name")[0].style.display = "none";
    }
    if(xhr.content.service2Name) {
        mui("#worker-service2Name")[0].innerHTML = xhr.content.service2Name;
    } else {
        mui("#worker-service2Name")[0].style.display = "none";
    }
    if(xhr.content.service3Name) {
        mui("#worker-service3Name")[0].innerHTML = xhr.content.service3Name;
    } else {
        mui("#worker-service3Name")[0].style.display = "none";
    }
    mui("#worker-serviceDetail")[0].innerHTML = xhr.content.serviceDetail ? xhr.content.serviceDetail : "";
    mui("#worker-serviceRange")[0].innerHTML = xhr.content.serviceRange ? xhr.content.serviceRange : "";
    mui("#worker-workerInfo")[0].innerHTML = xhr.content.workerInfo ? xhr.content.workerInfo : "";
    mui("#worker-favoriteVal")[0].innerHTML = xhr.content.favoriteVal ? xhr.content.favoriteVal : 0;
    mui("#worker-appointmentVal")[0].innerHTML = xhr.content.appointmentVal ? xhr.content.appointmentVal : 0;
    mui("#worker-pageviews")[0].innerHTML = xhr.content.workerPageviews ? xhr.content.workerPageviews : 0;
    mui("#worker-msgVal")[0].innerHTML = xhr.content.msgVal ? xhr.content.msgVal : 0;
    mui("#org-box")[0].style.display = xhr.content.workerOrg ? "block" : "none";
    xhr.content.workerOrg = xhr.content.workerOrg ? xhr.content.workerOrg : "";
    xhr.content.workerOrgAddr = xhr.content.workerOrgAddr ? xhr.content.workerOrgAddr : "";
    xhr.content.workerOrgTel = xhr.content.workerOrg ? xhr.content.workerOrgTel : "";
    var orgHtml = "";
    if(xhr.content.workerOrg) {
        orgHtml += xhr.content.workerOrg;
    }
    if(xhr.content.workerOrgAddr) {
        orgHtml += "<br />" + xhr.content.workerOrgAddr;
    }
    if(xhr.content.workerOrgTel) {
        orgHtml += "<br />" + xhr.content.workerOrgTel;
    }
    mui("#worker-org")[0].innerHTML = orgHtml;

    xhr.content.favorableVal = xhr.content.favorableVal ? xhr.content.favorableVal : 0;
    xhr.content.badVal = xhr.content.badVal ? xhr.content.badVal : 0;
    mui("#worker-favorableVal")[0].innerHTML = xhr.content.favorableVal;
    mui("#worker-unfavorableVal")[0].innerHTML = xhr.content.badVal;

    mui("#msg-textarea")[0].value = ""; //清空留言输入框

    if(xhr.content.switchWorkStatus == 1) {
        mui(".ms-bottom").on("tap", "#call", function() {
            if(_workerTel) {
                var btnArray = ['否', '是'];
                mui.confirm('确认拨打' + _workerTel + '?', '', btnArray, function(e) {
                    if(e.index == 1) {
                        plus.nativeUI.showWaiting();
                        userId = userId ? userId : "";
                        var data = {
                            userId: userId,
                            workerId: webView.userId
                        }
                        AJAX.post("appointment/save", data, function(xhr) {
                            plus.nativeUI.closeWaiting();
                            getAppointmentNum();
                            plus.device.dial(_workerTel);
                        }, function(xhr) {
                            plus.nativeUI.closeWaiting();
                            plus.device.dial(_workerTel);
                        });
                    }
                });
            } else {
                mui.toast("获取师傅联系方式失败");
            }
        });
    } else {
        document.getElementById("callText").innerHTML = "短信预约";
        mui(".ms-bottom").on("tap", "#call", function() {
            plus.nativeUI.prompt("师傅手机号" + _workerTel, function(e) {
                if(e.index == 1) {
                    plus.nativeUI.showWaiting();
                    var to = [_workerTel];
                    var msg = plus.messaging.createMessage(plus.messaging.TYPE_SMS);
                    msg.to = to;
                    msg.body = e.value;
                    msg.silent = true;
                    userId = userId ? userId : "";
                    var data = {
                        userId: userId,
                        workerId: webView.userId
                    }
                    AJAX.post("appointment/save", data, function(xhr) {
                        plus.nativeUI.closeWaiting();
                        getAppointmentNum();
                        plus.messaging.sendMessage(msg);
                    }, function(xhr) {
                        plus.messaging.sendMessage(msg);
                        plus.nativeUI.closeWaiting();
                    });
                }
            }, "发送短信", "请输入短信内容", ["取消", "发送"]);
        });
    }
    //注册
    document.getElementById("register_user.html").addEventListener("tap", function() {
        mui.openWindow({
            url: '../index/register_user.html',
            id: 'register_user.html',
            extras: {
                refereeTel: _workerTel,
            }
        });
    });
}