var choosePage = "skill",
    page = "skill",
    pageNum = 1, //师傅列表页码
    filter, //筛选条件
    searchStr, //搜索字符串
    pullAct = "", //记录是上拉还是下拉
    types, //分类大类数组
    genres = {}, //分类数组
    maxTypeDate, //分类最后修改时间
    _afterType, //选中的分类dom元素
    localFile = "js/skill.json", //本地保存升级描述目录和文件名
    wwwDir = null,
    docDir = null,
    localSkillType,
    localServiceType;
mui.init();
var deceleration = mui.os.ios ? 0.003 : 0.0009;
mui('.mui-scroll-wrapper').scroll({
    bounce: false,
    indicators: false, //是否显示滚动条
    deceleration: deceleration
});
mui.plusReady(function() {
    var lauchFlag = plus.storage.getItem("lauchFlag");
    if(lauchFlag != "true") {
        mui.openWindow({
            url: "guide.html"
        })
    } else {
        var t = setTimeout(function() {
            plus.navigator.closeSplashscreen(); // 关闭启动页
        }, 500);
        thisReady();
    }
});

function thisReady() {
    plus.storage.setItem("relocation", "true");
    var userCity = plus.storage.getItem("user_city");
    if(userCity) {
        if(userCity.length > 4) {
            userCity = userCity.substring(0, 4);
            userCity += "...";
        }
        document.getElementById("user-city").innerHTML = userCity;
    }
    getUserInfo(true);
    version();
    var autoLogin = plus.storage.getItem("user_auto_login");
    if(autoLogin == "false") {
        clearUserInfo();
    }
    var userId = plus.storage.getItem("user_id");
    if(userId) {
        getData();
    }
    mui(document.getElementById("mui-scroll")).pullToRefresh({
        down: {
            callback: function() {
                plus.nativeUI.showWaiting("", {
                    back: "transmit"
                });
                pageNum = 1;
                pullAct = "down";
                getMaxType();
            }
        },
        up: {
            callback: function() {
                pullAct = "up";
                getPosition();
            }
        }
    });
}
mui(".mui-bar-tab").on("tap", ".mui-tab-item", function() {
    if(this.id == choosePage) {
        return;
    }
    switch(this.id) {
        case "skill":
            document.getElementById("slider").style.top = "250px";
            document.getElementById("title-box").style.display = "block";
            page = "skill";
            localFile = "js/skill.json";
            recover();
            choosePage = "skill";
            getMaxType();
            //mui('#mui-scroll').pullToRefresh().pullDownLoading();
            break;
        case "service":
            document.getElementById("slider").style.top = "250px";
            document.getElementById("title-box").style.display = "block";
            page = "service";
            localFile = "js/service.json";
            recover();
            choosePage = "service";
            getMaxType();
            //mui('#mui-scroll').pullToRefresh().pullDownLoading();
            break;
        case "personal":
            choosePage = "personal";
            document.getElementById("slider").style.top = "44px";
            document.getElementById("title-box").style.display = "none";
            var userId = plus.storage.getItem("user_id");
            if(userId) {
                document.getElementById("login-box").style.display = "none";
                document.getElementById("personal-box").style.display = "block";
                getData();
            } else {
                document.getElementById("personal-box").style.display = "none";
                document.getElementById("login-box").style.display = "block";
            }
            break;
    }
});

function recover() {
    document.getElementById("worker-list").innerHTML = "";
    pageNum = 1;
    pullAct = "";
    filter = "";
    searchStr = "";
    types = null;
    genres = {};
    maxTypeDate = null;
    _afterType = null;
    wwwDir = null;
    docDir = null;
    mui('.mui-scroll-wrapper').scroll().scrollTo(0, 0, 100); //100毫秒滚动到顶
    thisFailCall();
}

function thisFailCall() {
    plus.nativeUI.closeWaiting();
    if(pullAct == "down") {
        mui('#mui-scroll').pullToRefresh().endPullDownToRefresh();
        mui('#mui-scroll').pullToRefresh().refresh(true);
    } else if(pullAct == "up") {
        mui('#mui-scroll').pullToRefresh().endPullUpToRefresh(false);
    }
}
//检查分类是否更新
function getMaxType() {
    plus.nativeUI.showWaiting();
    var url = "";
    if(page == "skill") {
        url = "getMaxSkillType";
    } else {
        url = "getMaxServiceType";
    }
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            maxTypeDate = xhr.content.val;
            if(page == "skill" && localSkillType) {
                if(localSkillType.lastModifiedTime == maxTypeDate) {
                    showTypeList(localSkillType.content, true);
                } else {
                    getType();
                }
            } else if(page == "service" && localServiceType) {
                if(localServiceType.lastModifiedTime == maxTypeDate) {
                    showTypeList(localServiceType.content, true);
                } else {
                    getType();
                }
            } else {
                openDocDir();
            }
        } else {
            mui.toast(xhr.msg ? xhr.msg : "");
        }
    }, function(xhr) {
        plus.nativeUI.closeWaiting();
        mui.toast("网络连接失败，请稍后重试");
    });
}

//打开运行资源目录
function openWwwDir() {
    plus.io.requestFileSystem(plus.io.PRIVATE_WWW, function(fs) {
        wwwDir = fs.root;
        getLocalData("www");
    }, function(e) {
        console.log("打开doc目录失败：" + e.message);
    });
}
//打开私有文档目录
function openDocDir() {
    plus.io.requestFileSystem(plus.io.PRIVATE_DOC, function(fs) {
        docDir = fs.root;
        getLocalData("doc");
    }, function(e) {
        console.log("打开doc目录失败：" + e.message);
    });
}
//获取本地数据
function getLocalData(mode) {
    var temp;
    temp = mode == "doc" ? docDir : wwwDir;
    // 读取本地升级文件
    temp.getFile(localFile, {
        create: false
    }, function(fentry) {
        fentry.file(function(file) {
            var reader = new plus.io.FileReader();
            reader.onloadend = function(e) {
                var data = null;
                try {
                    data = JSON.parse(e.target.result);
                    if(page == "skill") {
                        localSkillType = data;
                    } else if(page == "service") {
                        localServiceType = data;
                    }
                    if(data.lastModifiedTime == maxTypeDate) {
                        showTypeList(data.content, true);
                    } else {
                        getType();
                    }
                } catch(e) {
                    //本地文件，数据格式错误
                    openFail(mode);
                    return;
                }
            }
            reader.readAsText(file);
        }, function(e) {
            //读取失败
            openFail(mode);
        });
    }, function(e) {
        // 失败表示文件不存在
        openFail(mode);
    });
}
//打开文件失败
function openFail(mode) {
    if(mode == "doc") {
        openWwwDir();
    } else {
        //从服务器获取
    }
}
//写文件
function writeLocalFile(data) {
    if(page == "skill") {
        localSkillType = data;
    } else if(page == "service") {
        localSkillType = data;
    }
    if(typeof(data) == "object") {
        try {
            data = JSON.stringify(data);
        } catch(e) {
            console.log("保存文件，数据格式不正确,请传入JSON格式数据");
            return;
        }
    }
    plus.io.requestFileSystem(plus.io.PRIVATE_DOC, function(fs) {
        // 保存到本地文件中
        fs.root.getFile(localFile, {
            create: true
        }, function(fentry) {
            fentry.createWriter(function(writer) {
                writer.onerror = function(event) {
                    console.log("保存文件失败！" + JSON.stringify(event));
                }
                writer.write(data);
            }, function(e) {
                console.log("创建写文件对象失败：" + e.message);
            });
        }, function(e) {
            console.log("打开保存文件失败：" + e.message);
        });
    }, function(e) {
        console.log("打开doc目录失败：" + e.message);
    });
}
//获取分类大类
function getType() {
    AJAX.get("baseData/list?btype=" + page + "type", function(xhr) {
        if(xhr.status == 1) {
            types = xhr.content;
            for(var i in types) {
                genres[types[i].id] = [];
                types[i]["child"] = [];
            }
            getGenre();
            plus.storage.setItem(page + "_btype_types", JSON.stringify(types)); //保存大分类数据
        } else {
            thisFailCall();
            plus.nativeUI.closeWaiting();
        }
    }, function(xhr) {
        thisFailCall();
    });
}
//获取分类
function getGenre(i) {
    i = i ? i : 0;
    var typeId;
    if(types && i < types.length) {
        typeId = types[i].id;
        AJAX.get("baseData/list?btype=" + page + "&" + page + "TypeId=" + typeId, function(xhr) {
            if(xhr.status == 1) {
                groupGenre(xhr.content, typeId);
            } else {
                thisFailCall();
                plus.nativeUI.closeWaiting();
                mui.alert(xhr.msg ? xhr.msg : "获取分类失败，请重试");
            }
        }, function(xhr) {
            thisFailCall();
        });
    } else {
        showGenre();
    }
}

//组合分类数据

function groupGenre(data, idx) {
    for(var i in data) {
        genres[idx].push(data[i]);
    }
    getGenre(idx);
}
//显示分类
function showGenre() {
    for(var i in types) {
        types[i]["child"] = genres[types[i].id];
    }
    showTypeList(types);
}

function showTypeList(data, noWrite) {
    var fileData = {
        lastModifiedTime: maxTypeDate,
        content: data
    };
    var controls = document.getElementById("segmentedControls");
    var contents = document.getElementById("segmentedControlContents");
    var controlsHtml = [],
        contentsHtml = [],
        row, width;
    for(var i in data) {
        row = Math.ceil((data[i]["child"].length) / 4);
        width = row * 110;
        controlsHtml.push('<a class="mui-control-item control-item-cus" href="#content' + data[i].id + '">' + data[i].name + '</a>');
        contentsHtml.push('<div id="content' + data[i].id + '" class="mui-control-content"><ul style="width:' + width + 'px" class="mui-table-cus">');
        for(var j in data[i]["child"]) {
            contentsHtml.push('<li id="genres-' + data[i].id + "-" + data[i]["child"][j].id + '" type-id="' + data[i].id + '" genres-id="' + data[i]["child"][j].id + '" class="mui-h5 js-service ' + page + '">' + data[i]["child"][j].name + '</li>');
        }
        contentsHtml.push('</ul></div>');
    }
    controls.innerHTML = controlsHtml.join('');
    contents.innerHTML = contentsHtml.join('');
    //默认选中第一个
    controls.querySelector('.mui-control-item').classList.add('mui-active');
    contents.querySelector('.mui-control-content').classList.add('mui-active');
    if(_afterType) {
        _afterType = document.getElementById(_afterType.id);
        _afterType.classList.add("mg-active");
    }
    // 分类点击事件
    mui(".mui-control-content").on("tap", ".js-service", function(e) {
        mui('#pullrefresh').pullRefresh().scrollTo(0, 0, 100);
        plus.nativeUI.showWaiting("", {
            padlock: true
        });
        var after = _afterType;
        recover();
        if(after != this) {
            after && after.classList.remove("mg-active");
            this.classList.add("mg-active");
            _afterType = this;
            var genresId = this.getAttribute("genres-id");
            filter = "&" + page + "Id=" + genresId;
            mui('#mui-scroll').pullToRefresh().pullDownLoading();
        } else {
            this.classList.remove("mg-active");
            _afterType = null;
            mui('#mui-scroll').pullToRefresh().pullDownLoading();
        }
    });
    getPosition();
    !noWrite && writeLocalFile(fileData);
}

//定位
function getPosition() {
    var city = plus.storage.getItem("user_city");
    var relocation = plus.storage.getItem("relocation");
    getLocation(function(p) {
        var showCity = "";
        if(city) {
            if(relocation == "true") {
                plus.storage.setItem("relocation", "false");
                if(city == p.city) {
                    getWorkerList(p.latitude, p.longitude, p.city);
                } else {
                    mui.confirm("当前定位城市是" + p.city + "，是否切换", "提示", ["取消", "确认"], function(e) {
                        if(e.index) {
                            if(p.city.length > 4) {
                                showCity = p.city.substring(0, 4);
                                showCity += "...";
                            } else {
                                showCity = p.city;
                            }
                            document.getElementById("user-city").innerHTML = showCity;
                            plus.storage.setItem("user_city", p.city);
                            getWorkerList(p.latitude, p.longitude, p.city);
                        } else {
                            if(city.length > 4) {
                                showCity = city.substring(0, 4);
                                showCity += "...";
                            } else {
                                showCity = city;
                            }
                            document.getElementById("user-city").innerHTML = showCity;
                            getWorkerList(p.latitude, p.longitude, city);
                        }
                    });
                }
            } else {
                if(city.length > 4) {
                    showCity = city.substring(0, 4);
                    showCity += "...";
                } else {
                    showCity = city;
                }
                document.getElementById("user-city").innerHTML = showCity;
                getWorkerList(p.latitude, p.longitude, city);
            }
        } else {
            if(p.city.length > 4) {
                showCity = p.city.substring(0, 4);
                showCity += "...";
            } else {
                showCity = p.city;
            }
            document.getElementById("user-city").innerHTML = showCity;
            plus.storage.setItem("user_city", p.city);
            getWorkerList(p.latitude, p.longitude, p.city);
        }
        plus.storage.setItem("user_latitude", p.latitude.toString());
        plus.storage.setItem("user_longitude", p.longitude.toString());
    }, function(e) {
        if(city) {
            getWorkerList(false, false, city);
        } else {
            getWorkerList(false, false, "北京市");
            mui.alert("定位失败，请手动选择城市", function() {
                mui.openWindow({
                    url: "index/address_choose.html"
                });
            });
        }
    });
}
//获取师傅列表数据
function getWorkerList(lat, lon, city) {
    filter = filter ? filter : "";
    searchStr = searchStr ? searchStr : "";
    var gps = "";
    if(lat && lon) {
        gps = "&lat=" + lat + "&lag=" + lon;
    }
    var url = "userWorker/worker/list?city=" + city + gps + "&pageNum=" + pageNum + "&pageSize=5" + filter + searchStr;
    var userId = plus.storage.getItem("user_id");
    if(userId) {
        url += "&userId=" + userId;
    }
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            showWorkerList(xhr);
        } else {
            plus.nativeUI.closeWaiting();
            xhr.msg && mui.toast(xhr.msg);
        }
    }, function(xhr) {
        thisFailCall();
    });
}

//展示师傅列表
function showWorkerList(data) {
    getUserCount();
    var table = document.body.querySelector('#worker-list');
    var arr = checkData(data.content);
    if(pullAct == "down") {
        table.innerHTML = "";
    }
    if(data.total == 0) {
        document.getElementById('worker-list').innerHTML = "<p class='mui-text-center fail'>暂无好师傅，赶紧推荐赚奖励！</p>";
    }
    for(var i = 0; i < arr.length; i++) {
        delRepeat("worker-" + arr[i].id);
        arr[i].icon = replaceImgUrl(arr[i].icon);
        var li = document.createElement('li');
        li.className = 'mui-table-view-cell';
        li.innerHTML = '<a id="worker-' + arr[i].id + '" worder-userid="' + arr[i].id + '" class="mui-navigate-right">' +
            '    <div class="mui-row worker">' +
            '        <div class="mui-col-xs-2 ub-ver mui-text-center">' +
            '            <div style="line-height:1;"><img src="' + arr[i].icon + '" alt="' + arr[i].userName + '" /></div>' +
            '            <span style="color:#f5c898;text-align:center;font-size:12px;line-height:1.2;">' + arr[i].userType + '</span>' +
            '            <span class="worker-status mui-h6 ' + arr[i].statusClass + '">' + arr[i].statusText + '</span>' +
            '        </div>' +
            '        <div class="mui-col-xs-10 ub-ver">' +
            '            <div class="ub-pj mui-h7">' +
            '                <div class="mui-col-xs-8">' +
            '                    <span class="mui-h5" style="color:#000;">' + arr[i].userName + '</span>' +
            '                    <i class="ms txc-o" style="' + arr[i].certificationStyle + '">&#xe61c;</i><span style="' + arr[i].certificationStyle + '">' + arr[i].certificationText + '</span>' +
            '                </div>' +
            '                <div class="mui-col-xs-4 mui-text-left"><i class="ms txc-o">&#xe60b;</i>好评率:<span class="txc-o">' + arr[i].rate + '</span></div>' +
            '            </div>' +
            '            <div class="ub-pj mui-h7">' +
            '                <div class="mui-col-xs-8">师傅号：<span>' + arr[i].code + '</span></div>' +
            '                <div class="mui-col-xs-4 mui-text-left"><i class="ms txc-b">&#xe609;</i>浏览:<span class="txc-b">' + arr[i].workerPageviews + '</span></div>' +
            '            </div>' +
            '            <div class="mui-h6 worker-skill">' +
            '                技能：' + arr[i].skillList +
            '            </div>' +
            '            <div class="ub-pj mui-h6 worker-service">' +
            '                <div>服务：' + arr[i].serviceList + '</div>' +
            '                <div>' + arr[i].posHTML + '</div>' +
            '            </div>' +
            '        </div>' +
            '    </div>' +
            '</a>';
        table.appendChild(li);
        openDetail(arr[i].id);
    }
    if(pullAct == "down") {
        mui('#mui-scroll').pullToRefresh().endPullDownToRefresh();
        mui('#mui-scroll').pullToRefresh().refresh(true);
    } else if(pullAct == "up") {
        mui('#mui-scroll').pullToRefresh().endPullUpToRefresh(false);
    }
    if(data.hasNextPage) {
        pageNum = data.nextPage;
    } else if(pullAct) {
        mui('#mui-scroll').pullToRefresh().endPullUpToRefresh(true);
    }
    plus.nativeUI.closeWaiting();
}
//删除重复数据
function delRepeat(id) {
    var dom = document.getElementById(id);
    if(dom) {
        removeElement(dom.parentElement);
    }
}
//师傅列表数据检查重组
function checkData(data) {
    var screenWidth = plus.screen.resolutionWidth * plus.screen.scale;
    for(var i in data) {
        data[i].userName = data[i].userName ? data[i].userName : "";
        //距离
        if(data[i].pos) {
            var pos = (data[i].pos / 1000).toFixed(2);
            pos = pos > 0.01 ? pos : 0.01;
            pos = pos > 999 ? 999 : pos;
            data[i].posHTML = '<i class="ms txc-b">&#xe61e;</i><label class="mui-h6">' + pos + 'km</label>';
        } else {
            data[i].posHTML = "";
        }

        //人气
        if(!data[i].popuVal) {
            data[i].popuVal = 0;
        }
        //师傅类型 5:VIP
        if(data[i].typeId == 5) {
            data[i]["userType"] = "VIP";
        } else {
            data[i]["userType"] = "注册";
        }
        //工作状态
        if(data[i].switchWorkStatus == 1) {
            data[i]["statusClass"] = "active";
            data[i]["statusText"] = "在线";
        } else {
            data[i]["statusClass"] = "";
            data[i]["statusText"] = "隐身";
        }

        //身份认证
        if(data[i].certification == 1) {
            data[i]["certificationStyle"] = "";
            data[i]["certificationText"] = "实名登记";
        } else {
            data[i]["certificationStyle"] = "color:#999999;";
            data[i]["certificationText"] = "未实名登记";
        }

        //行业认证
        if(data[i].isindustry == 1) {
            data[i]["isindustryStyle"] = "";
        } else {
            data[i]["isindustryStyle"] = "color:#999999;";
        }
        data[i]["skillList"] = "";
        if(data[i].skill1Name) {
            data[i]["skillList"] += "<span>" + data[i].skill1Name + "</span>";
        }
        if(data[i].skill2Name) {
            data[i]["skillList"] += "<span>" + data[i].skill2Name + "</span>";
        }
        data[i]["serviceList"] = "";
        data[i].service1Name = data[i].service1Name ? data[i].service1Name : "";
        data[i].service2Name = data[i].service2Name ? data[i].service2Name : "";
        data[i].service3Name = data[i].service3Name ? data[i].service3Name : "";
        if(data[i].service1Name) {
            data[i]["serviceList"] += "<span>" + data[i].service1Name + "</span>";
        }
        if(data[i].service2Name) {
            var serviceTwo = data[i].service1Name + data[i].service2Name;
            if(serviceTwo.length < (screenWidth / 60)) {
                data[i]["serviceList"] += "<span>" + data[i].service2Name + "</span>"
            }
        }
    }
    return data;
}
//绑定item点击事件
function openDetail(id) {
    mui("#worker-list").on('tap', "#worker-" + id, function() {
        mui.openWindow({
            url: 'tab_skill/worker_detail.html',
            id: 'worker_detail.html',
            extras: {
                userId: this.getAttribute("worder-userid")
            }
        });
    });
}
//搜索框
document.getElementById('search-btn').addEventListener('tap', function() {
    var str = mui("#search-txt")[0].value;
    if(str.trim() == "") {
        searchStr = "";
    } else {
        searchStr = "&searchstr=" + str;
    }
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    mui('#mui-scroll').pullToRefresh().pullDownLoading();
});
mui('.mui-search-cus').on('submit', '#search-form', function() {
    mui("#search-txt")[0].blur();
    var str = mui("#search-txt")[0].value;
    if(str.trim() == "") {
        searchStr = "";
    } else {
        searchStr = "&searchstr=" + str;
    }
    plus.nativeUI.showWaiting("", {
        padlock: true
    });
    mui('#mui-scroll').pullToRefresh().pullDownLoading();
    return false;
});
//城市选择点击事件
document.getElementById("address").addEventListener("tap", function() {
    mui.openWindow({
        url: "index/address_choose.html"
    });
});
//联系我们点击事件
document.getElementById("feedback").addEventListener("tap", function() {
    mui.openWindow({
        url: "index/feedback.html"
    });
});
//自定义选择地址
document.addEventListener("updatecity", function() {
    var city = plus.storage.getItem("user_city");
    if(city.length > 4) {
        city = city.substring(0, 4);
        city += "...";
    }
    document.getElementById("user-city").innerHTML = city;
    recover();
    getMaxType();
});
var Time = null;

function updateGPS() {
    var userId = plus.storage.getItem("user_id");
    if(!userId) {
        return;
    }
    getLocation(function(p) {
        var data = {
            id: userId,
            lat: p.latitude,
            lag: p.longitude,
            city: p.city
        }
        var url = "user/updateLbs/update/" + userId;
        AJAX.post(url, data, function(xhr) {
            Time && window.clearTimeout(Time);
            var exTime = plus.storage.getItem("user_switch_gps");
            if(exTime == "open") {
                Time = window.setTimeout(updateGPS, 30000);
            }
        }, function(xhr) {});
    }, function(e) {
        //mui.toast(e);
    });
}
document.addEventListener("gopersonal", function() {
    document.getElementById("personal-box").style.display = "none";
    document.getElementById("login-box").style.display = "block";
});
/**
 * 获取当前用户数量
 */
function getUserCount() {
    var url = "user/getCount";
    AJAX.get(url, function(xhr) {
        if(xhr.status == 1) {
            document.getElementById("userCount").style.display = "block";
            document.getElementById("userCount").innerHTML = "当前用户:" + xhr.content.val;
        } else {
            document.getElementById("userCount").style.display = "none";
        }
    }, function(xhr) {
        mui.toast("网络连接失败，请稍后重试");
    });
}