var masterMenu = ["master_data.html", "records.html", "master_setting.html", "o2o_card.html"],
    promoterMenu = ["promoter_data.html", "promoter_apply.html", "o2o_card_suggest.html", "promoter_setting.html"],
    prepareMenu = ["master_data.html", "records.html", "master_setting.html", "o2o_card.html"],
    userMenu = ["user_setting.html", "user_data.html", "master_prepare"];
var userInfo;
document.getElementById("master_prepare").addEventListener("tap", function() {
    mui.confirm("完善资料，即可升级为好师傅", "提示", ["我再想想", "现在升级"], function(e) {
        if(e.index) {
            var data = dataCheck(userInfo);
            mui.openWindow({
                url: "tab_personal/master_data_update.html",
                id: "master_data_update.html",
                extras: {
                    data: data,
                    act: "promotion"
                }
            });
        }
    });
});
mui("#tab_personal").on("tap", ".open", function() {
    var url = this.id;
    var styles = {};
    if(!url) {
        return;
    } else if(url == "o2o_card.html") {
        styles["hardwareAccelerated"] = true;
    }
    powerCheck(url) && mui.openWindow({
        url: "tab_personal/" + url,
        id: url,
        styles: styles,
        waiting: {
            autoShow: false
        }
    });
});

function powerCheck(url) {
    var userType = plus.storage.getItem("user_type");
    if(userType == 3) {
        for(var i in masterMenu) {
            if(url == masterMenu[i] && url != "master_data.html" && url != "master_setting.html") {
                mui.confirm("完善个人资料后才能打开哦～", "提示", ["稍后完善", "现在完善"], function(e) {
                    if(e.index) {
                        var data = dataCheck(userInfo);
                        mui.openWindow({
                            url: "tab_personal/master_data_update.html",
                            id: "master_data_update.html",
                            extras: {
                                data: data,
                                act: "promotion"
                            }
                        });
                    }
                });
                return false;
            }
        }
    }
    return true;
}

function getData() {
    userInfo = plus.storage.getItem("user_info");
    if(!userInfo) {
        mui.alert("获取用户信息失败，请重新登录", function() {
            logout();
        });
        return;
    }
    userInfo = JSON.parse(userInfo);
    document.getElementById("usename").innerHTML = userInfo.userName ? userInfo.userName : ""; //用户名
    document.getElementById("tel").innerHTML = userInfo.tel; //电话
    document.getElementById("user-pic").src = userInfo.icon; //头像
    document.getElementById("superCode").innerHTML = userInfo.superCode; //推荐人
    document.getElementById("code").innerHTML = userInfo.code; //师傅号
    document.getElementById("userRegDay").innerHTML = userInfo.userRegDay; //注册时间
    showMenu();
}

function showMenu() {
    hideMenu();
    var type = userMenuPower();
    var menuList;
    switch(type) {
        case "master":
            menuList = masterMenu;
            break;
        case "promoter":
            menuList = promoterMenu;
            break;
        case "prepare":
            menuList = prepareMenu;
            break;
        case "user":
            menuList = userMenu;
            break;
    }
    for(var i in menuList) {
        document.getElementById(menuList[i]).style.display = "block";
    }
}

function userMenuPower() {
    var id = plus.storage.getItem("user_type");
    var userType;
    switch(id) {
        case "1":
        case "2":
            userType = "user";
            break;
        case "3":
            userType = "prepare";
            break;
        case "4":
        case "5":
            userType = "master";
            document.getElementById("cardTip").style.display = "block";
            break;
        case "6":
        case "7":
            userType = "promoter";
            break;
    }
    return userType;
}

function hideMenu() {
    for(var i in masterMenu) {
        document.getElementById(masterMenu[i]).style.display = "none";
    }
    for(var i in promoterMenu) {
        document.getElementById(promoterMenu[i]).style.display = "none";
    }
    for(var i in prepareMenu) {
        document.getElementById(prepareMenu[i]).style.display = "none";
    }
    for(var i in userMenu) {
        document.getElementById(userMenu[i]).style.display = "none";
    }
}

function dataCheck(data) {
    if(!data.userName) {
        data.userName = "";
    }
    if(!data.serviceDetail) {
        data.serviceDetail = "";
    }
    if(!data.serviceRange) {
        data.serviceRange = "";
    }
    if(!data.workerInfo) {
        data.workerInfo = "";
    }
    if(!data.skill1Name) {
        data.skill1Name = "";
    }
    if(!data.skill2Name) {
        data.skill2Name = "";
    }
    if(!data.service1Name) {
        data.service1Name = "";
    }
    if(!data.service2Name) {
        data.service2Name = "";
    }
    if(!data.service3Name) {
        data.service3Name = "";
    }
    if(!data.workerOrg) {
        data.workerOrg = "";
    }
    if(!data.workerOrgAddr) {
        data.workerOrgAddr = "";
    }
    if(!data.workerOrgTel) {
        data.workerOrgTel = "";
    }
    return data;
}
document.getElementById("user-pic").addEventListener("tap", function() {
    var userId = plus.storage.getItem("user_id");
    var userType = plus.storage.getItem("user_type");
    if(userType == MASTER_TYPE || userType == VIP_MASTER_TYPE) {
        mui.openWindow({
            url: 'tab_skill/worker_detail.html',
            id: 'worker_detail.html',
            extras: {
                userId: userId
            }
        });
    }
});